
`timescale 1 ns / 1ns
module  alu( a_in , b_in , alu_function , c_alu ) ;
	input [31:0]a_in;
	input [31:0]b_in;
	input [3:0]alu_function;
	output [31:0]c_alu;
	wire less_than;
	wire[32:0] sum;
	wire carry;
	assign sum = (alu_function == 4'b0001) ? a_in+b_in : a_in + ~b_in + 32'h00000001 ;
	assign less_than = (a_in[31] ==  b_in[31] || alu_function == 4'b0011 ) ? sum[32] : a_in[31] ;				
	assign c_alu = 	(alu_function == 4'b0001) ? sum[31:0] :
					( alu_function == 4'b0010) ? sum[31:0] : 
					( alu_function == 4'b0011 ) ? { 31'b0 , less_than } :
					( alu_function == 4'b0100 ) ? { 31'b0 , less_than } :
					( alu_function == 4'b0101 ) ? a_in|b_in : 
					( alu_function == 4'b0110 ) ? a_in&b_in: 
					( alu_function == 4'b0111 ) ? a_in^b_in	: 
					( alu_function == 4'b1000 ) ? ~(a_in|b_in) : 32'h00000000 ;
	//always @(alu_function or a_in )
	//begin
	//	if ( alu_function == 4'b0111) 
	//	begin
	//		$display( "%h %h" , a_in , b_in ) ;
	//	end
	//end	
endmodule