module ram (clk, reset, enable, write_byte_enable, address, data_write, data_read);
input clk;
input reset;
input enable;
input [3:0] write_byte_enable;
input [31:2] address;
input [31:0] data_write;
output reg [31:0] data_read;

parameter ADDRESS_WIDTH = 13;
parameter mem_size = 2 ** ADDRESS_WIDTH;
parameter file_name = "code.txt";

reg [31:0] data;

reg [31:0] storage [0 : mem_size/4 - 1];
      


always @( posedge clk)
begin
	if( reset == 1'b1 )
		$readmemh(file_name, storage);
	else
	begin
        data = storage[address[ADDRESS_WIDTH-1:2]];

        if (enable == 1'b1)
		begin
            if (write_byte_enable[0] == 1'b1 )
               data[7:0] = data_write[7:0];
            if (write_byte_enable[1] == 1'b1)
               data[15:8] = data_write[15:8];
            if (write_byte_enable[2] == 1'b1)
               data[23:16] = data_write[23:16];
            if (write_byte_enable[3] == 1'b1)
               data[31:24] = data_write[31:24];
        end
		if (write_byte_enable != 4'b0000)
            storage[address[ADDRESS_WIDTH-1:2]] = data;      
	end
	
end
always @(enable, write_byte_enable, address, data_write, data)
begin
	data_read = data;
end

endmodule
